"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.OAuthHandler = void 0;
const oauth2_server_1 = __importDefault(require("oauth2-server"));
const model_1 = require("./model");
class OAuthHandler {
    getAuthProvider() {
        return this.app.oauth;
    }
    create(app, modalStore, context) {
        let oauth = oauth2_server_1.default({
            model: modalStore,
            grants: ["password", "refresh_token", "client_credentials", "authorization_code"],
            debug: true,
        });
        oauth.regex.clientId = '[A-Fa-f0-9]{3,64}';
        var grantCart = () => {
            let grant = app.oauth.grant();
            return (req, res, next) => {
                modalStore.findCredentials(req);
                grant(req, res, next);
            };
        };
        app.oauth = oauth;
        app.post(context + '/oauth/token', grantCart());
        app.use(oauth.errorHandler());
    }
    findAuthorize(app) {
        let authorise = app.oauth.authorise();
        return (req, res, next) => {
            let wReq = Object.create(req);
            wReq.get =
                wReq.header = function header(name) {
                    var lc = name.toLowerCase();
                    if (lc === 'authorization') {
                        if (req.get('tharak-auth'))
                            return req.get('tharak-auth');
                        else
                            return req.get(lc);
                    }
                    else {
                        return req.get(name);
                    }
                };
            authorise(wReq, res, next);
        };
    }
    getAppId(bearerToken, callback) {
        model_1.Model.getAppId(bearerToken, callback);
    }
    addHandler(config) {
        this.app = config.app;
        let modalStore = new model_1.Model(config.clientConfig, config.dispatcher, config.util);
        this.create(this.app, modalStore, config.clientConfig.serviceContext);
    }
    addHandler2(config) {
        this.app = config.app;
        let modalStore = new model_1.Model(config.apps, config.dispatcher, config.util);
        config.apps.forEach((app) => {
            this.create(this.app, modalStore, app.serviceContext);
        });
    }
    addHandler3(config) {
        this.app = config.app;
        let modalStore = new model_1.Model(config.apps, config.dispatcher, config.util);
        config.apps.forEach((app) => {
            this.create(this.app, modalStore, config.defAppId + app.serviceContext);
        });
    }
    onInit(config) {
        if (!config)
            return;
    }
}
exports.OAuthHandler = OAuthHandler;
//# sourceMappingURL=o-auth-handler.js.map